# {{ ansible_managed }}

# /etc/network/interfaces contains network interface configuration information for the ifup(8), ifdown(8) and
# ifquery(8) commands.

# This is where you configure how your system is connected to the network.

# Lines starting with "#" sign are ignored. NOTE(!!!): that end-of-line comments are NOT supported, comments must be on
# a line of their own.

# A line may be extended across multiple lines by making the last character a backslash.

# The file consists of zero or more "iface", "auto",  "allow-" and "source" stanzas.

# The loopback configuration must appear first in /etc/network/interfaces to prevent networking issues.
auto lo
iface lo inet loopback

{% for item in interfaces_eth_interfaces %}
auto {{ item.device }}
{% if item.allow is defined %}
allow-{{ item.allow }} {{ item.device }}
{% endif %}
{% if item.bootproto == 'static' or item.bootproto == 'manual' %}
iface {{ item.device }} {{ item.family|default('inet',true) }} {{ item.bootproto }}
{% if item.mtu is defined %}
    mtu {{ item.mtu }}
{% endif %}
{% if item.address is defined %}
    address {{ item.address }}
{% endif %}
{% if item.netmask is defined %}
    netmask {{ item.netmask }}
{% endif %}
{% if item.network is defined %}
    network {{ item.network }}
{% endif %}
{% if item.broadcast is defined %}
    broadcast {{ item.broadcast }}
{% endif %}
{% if item.gateway is defined %}
    gateway {{ item.gateway }}
{% endif %}
{% endif %}
{% if item.bootproto == 'dhcp' %}
iface {{ item.device }} {{ item.family|default('inet',true) }} dhcp
{% endif %}
{%- if item.route is defined %}
{%- for route in item.route %}
    up route add -net {{ route.network }}{{ ' netmask ' ~ route.netmask if route.netmask is defined else '' }}{{ ' gw ' ~ route.gateway if route.gateway is defined else '' }}{{ ' metric ' ~ route.metric if route.metric is defined else '' }} dev {{ item.device }}{{ ' || /bin/true' if item.route|length >1 else '' }}
{% endfor -%}
{%- for route in item.route %}
    down route del -net {{ route.network }}{{ ' netmask ' ~ route.netmask if route.netmask is defined else '' }}{{ ' gw ' ~ route.gateway if route.gateway is defined else '' }}{{ ' metric ' ~ route.metric if route.metric is defined else '' }} dev {{ item.device }}{{ ' || /bin/true' if item.route|length >1 else '' }}
{% endfor -%}
{% endif -%}
{%- if item.pre_up is defined %}
{%- for pre_up in item.pre_up %}
    pre-up {{ pre_up }}
{% endfor -%}
{% endif -%}
{%- if item.up is defined %}
{%- for up in item.up %}
    up {{ up }}
{% endfor -%}
{% endif -%}
{%- if item.down is defined %}
{%- for down in item.down %}
    down {{ down }}
{% endfor -%}
{% endif -%}
{%- if item.post_down is defined %}
{%- for post_down in item.post_down %}
    post-down {{ post_down }}
{% endfor -%}
{% endif -%}
{% endfor %}
